/* Demo program.

   Copyright 2007 Kevin Ryde

   This file is part of Redc1.

   Redc1 is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.

   Redc1 is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with Redc1; see the file COPYING.  If not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
   USA.  */

#include <stdio.h>
#include <stdlib.h>
#include "redc1.h"


int
main (void)
{
  mp_limb_t  N, Ninv, RmodN, R2modN, x, xR, y, yR, z, zR;

  /* the modulus (must be an odd number) */
  N = 999;

  /* values dependent on N, needed by the calculations */
  REDC1_INIT_Ninv (Ninv, N);
  REDC1_INIT_RmodN (RmodN, N);
  REDC1_INIT_R2modN (R2modN, N, RmodN);

  /* operands */
  x = 123;
  y = 456;

  /* input conversion: xR and yR residue forms of x and y */
  REDC1_IN (xR, x, N, Ninv, R2modN);
  REDC1_IN (yR, y, N, Ninv, R2modN);

  /* multiply z = x * y, in redc residues */
  REDC1_MUL (zR, xR, yR, N, Ninv);

  /* output conversion: z extracted from zR */
  REDC1_OUT (z, zR, N, Ninv);


  printf ("%lu * %lu modulo %lu is %lu\n", x, y, N, z);
  return 0;
}
